// Juhe  help:http://www.rstack.com.cn/
package main

import (
	"crypto/md5"
	"crypto/tls"
	"encoding/hex"
	"fmt"
	"io/ioutil"
	"log"

	"net/http"
	"net/url"
	"os"
	"regexp"
	"strings"
	"time"

	"github.com/Unknwon/goconfig"
	"github.com/pingo"
)

var (
	scheme         = "" // 1=https://   0=http://
	encryption_key = "" //取本地app.conf文件中的enkey
	SSLs           = ""
)

type Juhe struct{}

func main() {
	plugin := &Juhe{}
	pingo.Register(plugin)
	pingo.Run()

}

func (p *Juhe) Action(mapPublic map[string]string, msg *string) error {

	result := "-1|The variable is empty"

	rstack_domain := mapPublic["rstack_domain"]
	rstack_ssl := mapPublic["rstack_ssl"]

	scheme = "http://"
	if rstack_ssl == "1" {
		scheme = "https://"
	}

	SSLs = rstack_ssl
	if SSLs != "0" && SSLs != "1" {
		SSLs = "0"
	}

	//财务设定的短信签名，如果有的短信接口需要传输自己的签名则用这个传输即可，不过大部门都没有的。
	//sms_signature := mapPublic["sms_signature"]

	smsid := mapPublic["smsid"]
	//短信类型。
	action := mapPublic["action"]
	//短信内容：
	content := mapPublic["content"]
	//短信手机,如果多个手机号会以,分割，请自己分割批量提交接口，可以先做个判断存在,则多手机，否则1个号码
	mobile := mapPublic["mobile"]

	if action == "send" {

		resellerMode := IF(!IsNum(mapPublic["resellerMode"]), "0", mapPublic["resellerMode"])
		resellerID := IF(!IsNum(mapPublic["resellerID"]), "0", mapPublic["resellerID"])

		curl1 := scheme + rstack_domain + mapPublic["rstack_requesturi"]

		smsid := IF(!IsNum(mapPublic["smsid"]), "0", mapPublic["smsid"])

		//获取模块自定义参数
		text := GetSMSParameter(encryption_key, smsid, curl1, resellerMode, resellerID, rstack_domain)
		//fmt.Println("返回数据：", text)
		if strings.HasPrefix(text, "-1|") == true {
			result = text
		} else {
			apiURL := GetValue(text, "apiURL")

			appKEY := GetValue(text, "appKEY")

			if strings.Index(content, "|") < 0 {
				/*
					 聚合要求：提供短信模板ID， 我们财务系统只提供了一个内容的 所以要兼容 故需要在财务内容模板 设置格式  模板ID|变量名
					但是像塞邮的话，就直接支持直接内容发送，所以定义在财务短信内容里面即可，提取内容发送即可
				*/
				result = "-1|短信模板格式不正确,请以格式 模板ID|变量填写"
			} else {
				arrayTP := strings.Split(content, "|")

				mapPost := make(map[string]string)

				mapPost["mobile"] = mobile
				mapPost["tpl_id"] = arrayTP[0]
				mapPost["tpl_value"] = arrayTP[1]
				mapPost["key"] = appKEY
				cstr, err := ModulePostData(apiURL, mapPost, 15)
				if err != nil {
					result = "-1|" + fmt.Sprint(err)
				} else {
					//处理
					error_code := GetValue(cstr, "error_code")
					if error_code == "0" {
						//成功返回
						result = "0|0"
					} else {
						switch error_code {
						case "10001":
							result = "-1|错误的请求KEY"
						case "10002":
							result = "-1|该KEY无请求权限"
						case "10003":
							result = "-1|KEY过期"
						case "10004":
							result = "-1|错误的OPENID"
						case "10005":
							result = "-1|应用未审核超时，请提交认证"
						case "10007":
							result = "-1|未知的请求源"
						case "10008":
							result = "-1|被禁止的IP"
						case "10009":
							result = "-1|被禁止的KEY"
						case "10011":
							result = "-1|当前IP请求超过限制"
						case "10012":
							result = "-1|请求超过次数限制"
						case "10013":
							result = "-1|测试KEY超过请求限制"
						case "10014":
							result = "-1|系统内部异常(调用充值类业务时，请务必联系客服或通过订单查询接口检测订单，避免造成损失)"
						case "10020":
							result = "-1|接口维护"
						case "10021":
							result = "-1|接口停用"
						case "205401":
							result = "-1|错误的手机号码"
						case "205402":
							result = "-1|错误的短信模板ID"
						case "205403":
							result = "-1|网络错误,请重试"
						case "205404":
							result = "-1|发送失败，具体原因请参考返回reason"
						case "205405":
							result = "-1|号码异常/同一号码发送次数过于频繁"
						case "205406":
							result = "-1|不被支持的模板"
						case "205407":
							result = "-1|批量发送号码超限"
						case "205408":
							result = "-1|批量发送库存次数不足"
						case "205409":
							result = "-1|系统繁忙，请稍后重试"
						case "205410":
							result = "-1|请求方法错误"
						default:
							result = "-1|接口错误码：" + error_code
						}
					}

				}
			}

		}

	} else if action == "admin_sms_config" || action == "reseller_sms_config" {
		//加载模块设置参数
		subaction := mapPublic["subaction"]
		sign := mapPublic["sign"]

		enSign1 := Md5_default(action + subaction + encryption_key + smsid)

		if enSign1 == sign {
			text2 := Module_OpenFile("Juhe", action)
			if strings.HasPrefix(text2, "-1") == false {
				result = text2
			} else {
				result = "-1|Script file not found!"
			}

		} else {
			result = "-1|Invalid sign|0"
		}
	}

	*msg = result

	return nil
}

func Post(apiURL string, params url.Values) (rs []byte, err error) {
	resp, err := http.PostForm(apiURL, params)
	if err != nil {
		return nil, err
	}
	defer resp.Body.Close()
	return ioutil.ReadAll(resp.Body)
}

func GetSMSParameter(encryption_key string, smsid string, currentUrl string, resellerMode string, resellerID string, rHost string) string {

	//curl := currentUrl

	//去尾巴
	if currentUrl != "" {
		currentUrl = currentUrl[0 : strings.LastIndex(currentUrl, "/")+1]
	}

	map1 := make(map[string]string)
	map1["apiDomain"] = ""
	map1["action"] = "get_parameter" //获取模块config字段的JSON自定义参数。
	map1["type"] = "sms"
	map1["resellerMode"] = resellerMode
	map1["resellerID"] = resellerID
	map1["smsid"] = smsid
	map1["sign"] = Md5_default(smsid + encryption_key + currentUrl)

	cstr, err := ModulePostData(scheme+rHost+"/process?c=modules", map1, 5)
	if err != nil {
		return "-1|get_parameter Error:" + fmt.Sprint(err)
	}

	return cstr

}

//模块提交POST交互
func ModulePostData(urladdr string, map1 map[string]string, timeout int) (ret string, err error) {
	var client *http.Client
	if strings.HasPrefix(urladdr, "https://") == true {
		tr := &http.Transport{
			TLSClientConfig: &tls.Config{InsecureSkipVerify: true},
		}
		client = &http.Client{Transport: tr}
	} else {
		client = &http.Client{}
	}

	fields := ""
	for k, v := range map1 {
		if fields == "" {
			fields = k + "=" + v
		} else {
			fields += "&" + k + "=" + v
		}
	}

	req, err := http.NewRequest("POST", urladdr, strings.NewReader(fields))
	if err != nil {
		return "", err
	}

	req.Header.Add("Content-Type", "application/x-www-form-urlencoded")
	req.Header.Add("Accept", "*/*")
	req.Header.Add("User-Agent", "RStack Platform/1.0")

	resp, err := client.Do(req)
	if err != nil {
		return "", err
	}

	defer resp.Body.Close()

	body, err := ioutil.ReadAll(resp.Body)

	if err != nil {
		return "", err
	}

	return string(body), nil
}

//打开文件错误返回 -1|错误信息
func Module_OpenFile(moduleName string, str string) string {
	result := ""
	var err error
	if str != "" {
		result, err = OpenFile("static/modules/sms/" + moduleName + "/js/" + str + ".js")
		if err != nil {
			result = "-1|Script file not found"
			return result
		}
	}

	return result

}

func GetValue(json, string_0 string) string {
	text := ""

	string_0 = "\"" + string_0 + "\":" //也就是 如 "pid":

	if strings.Index(json, string_0) > -1 {
		//"9","name":"2G产品2048内存","remark":"&lt;
		text = json[strings.Index(json, string_0)+len(string_0):]
		//fmt.Println("第一：", text)
		num := 0
		num2 := 0

		if strings.HasPrefix(text, "\"") == true {

			//如果前面  "开头的 代表字符串JSON内容
			if strings.Index(text, "\",\"") > -1 {

				//如果找到 ","
				num2 = strings.Index(text, "\",\"")

			} else {
				num2 = strings.LastIndex(text, "\"")
			}
			num = 1
			//num2-- //如果加了这句 会获取不到 或则缺少东西
		} else if strings.HasPrefix(text, "{") == true {

			//如果是内置JSON到JSON
			if strings.Index(text, "\"},\"") > 0 {

				//找到 "},"
				num2 = strings.Index(text, "\"},\"") + 2 //   "},"
			} else if strings.Index(text, "\"}") > 0 { // "}

				num2 = strings.Index(text, "\"}") + 2
			} else if strings.Index(text, "}") > 0 { // }

				num2 = strings.Index(text, "}") + 1
			}

		} else if strings.Index(text, ",") > -1 {
			num2 = strings.Index(text, ",")
		} else {

			num2 = strings.Index(text, "}")
		}

		if num > num2 {
			//防止索引错误导致程序异常。
			text = ""
		} else {
			text = text[num:num2]
		}

		if strings.HasPrefix(text, "{") == false && strings.Index(text, "\"") > -1 {
			text = text[0:strings.Index(text, "\"")]

		}
	}

	return text
}

func Md5_default(md5_default string) string {
	h := md5.New()

	h.Write([]byte(md5_default))

	return hex.EncodeToString(h.Sum(nil))
}

func IF(ifstr bool, true1, false2 string) string {
	if ifstr {
		return true1
	}
	return false2
}

//可以匹配 浮点数 整数等。
func IsNum(isnumber string) bool {

	b2, err := regexp.MatchString("^[+-]?\\d*[.]?\\d*$", isnumber)
	if err != nil {
		return false
	}
	return b2 && isnumber != ""
}

func OpenFile(path string) (str string, err error) {
	f, err := os.Open(path)
	if err != nil {
		return "", err
	}

	str0, err := ioutil.ReadAll(f)

	if err != nil {
		return "", err
	}

	str = string(str0)

	return str, nil
}

func init() {
	pwd, err := os.Getwd()
	if err != nil {

		log.Println("Get Pwd Error：", err)
		return
	} else {
		pwd = strings.Replace(pwd, "\\", "/", -1)
		pwd = strings.Replace(pwd, "/bin", "", -1)

		cfg, err := goconfig.LoadConfigFile(pwd + "/conf/app.conf")
		if err != nil {
			log.Println("Load app.conf Error:", err)
		} else {

			enKey, err := cfg.GetValue("listen", "enKey")
			if err != nil {
				log.Println("Get listen domain", err)
				return
			}
			encryption_key = enKey

			//如果未设置，随机生成一个字符串enKey，让API失效。
			if encryption_key == "" {
				encryption_key = time.Now().Format("20060102150405")
			}
		}
	}
}
